extends Node

enum STATE {SPLASH, MENU, CUTSCENE, INGAME, GAMEOVER, CREDITS, OPTIONS}

var in_transition = false

var game_state = STATE.MENU
var inventory : Array
var score = 0
var secrets_found = 0

var arcade_mode = false
var level_list  = ["Googolplexian","Level"]
var level_names = ["Googolplexian","Test Level"]
var current_level = 0

onready var game_root = get_node("/root/Game")
onready var hud = get_node("/root/Game/HUD")

func show_message(msg):
	hud.show_message(msg,false)

func reset_everything():
	secrets_found = 0
	score = 0
	hud.seconds = 0
	hud.minutes = 0
	hud.clock.text = "00:00"
	clear_inventory()
	show_message("")

func has_item(item):
	return inventory.has(item)

func add_item(item):
	if !has_item(item):
		inventory.append(item)

func remove_item(item):
	inventory.erase(item)

func clear_inventory():
	inventory.clear()

func update_item_hud():
	hud.update_items()
